# First, set up the Basic Authentication header with your email and password to WellTraq
$username = "YOUR USERNAME"
$password = "YOUR PASSWORD"
$encoded = [System.Convert]::ToBase64String([System.Text.Encoding]::UTF8.GetBytes($username + ":" + $password))


Write-Host "Let's create a new asset type, group, measurement type, and asset..."
$newAssetType = @{}
$newAssetType.Name = "My Asset Type"

$apiResponse = Invoke-RestMethod -Uri "https://www.welltraq.com/api/v1/assettypes/assettype" -Headers @{Authorization=("Basic {0}" -f $encoded)} -Method Post -Body ($newAssetType|ConvertTo-Json) -ContentType "application/json"
$newAssetType = $apiResponse.Data

$decimalDataType = @{}
$decimalDataType.DataTypeId = "97A7E35A-0063-4711-8CE6-A0303D2300C0"

$newMeasurementType = @{}
$newMeasurementType.Name = "My Measurement Type"
$newMeasurementType.DataType = $decimalDataType
$newMeasurementType.AssetType = $newAssetType

$apiResponse = Invoke-RestMethod -Uri "https://www.welltraq.com/api/v1/measurementtypes/measurementtype" -Headers @{Authorization=("Basic {0}" -f $encoded)} -Method Post -Body ($newMeasurementType|ConvertTo-Json) -ContentType "application/json"
$newMeasurementType = $apiResponse.Data

$newAssetGroup = @{}
$newAssetGroup.Name = "My Group"

$apiResponse = Invoke-RestMethod -Uri "https://www.welltraq.com/api/v1/assetgroups/assetgroup" -Headers @{Authorization=("Basic {0}" -f $encoded)} -Method Post -Body ($newAssetGroup|ConvertTo-Json) -ContentType "application/json"
$newAssetGroup = $apiResponse.Data

$newAsset = @{}
$newAsset.Name = "My Asset"
$newAsset.AssetType = $newAssetType
$newAsset.AssetGroup = $newAssetGroup

$apiResponse = Invoke-RestMethod -Uri "https://www.welltraq.com/api/v1/assets/asset" -Headers @{Authorization=("Basic {0}" -f $encoded)} -Method Post -Body ($newAsset|ConvertTo-Json) -ContentType "application/json"
$newAsset = $apiResponse.Data


Write-Host "Now let's update the asset's name..."
$newAsset.Name = "My New Asset Name"
$apiResponse = Invoke-RestMethod -Uri "https://www.welltraq.com/api/v1/assets/asset" -Headers @{Authorization=("Basic {0}" -f $encoded)} -Method Put -Body ($newAsset|ConvertTo-Json) -ContentType "application/json"
$newAsset = $apiResponse.Data


Write-Host "Now let's delete all the items we just made..."
$apiResponse = Invoke-RestMethod -Uri "https://www.welltraq.com/api/v1/assettypes/assettype" -Headers @{Authorization=("Basic {0}" -f $encoded)} -Method Delete -Body ($newAssetType|ConvertTo-Json) -ContentType "application/json"
$newAssetType = $apiResponse.Data

$apiResponse = Invoke-RestMethod -Uri "https://www.welltraq.com/api/v1/assetgroups/assetgroup" -Headers @{Authorization=("Basic {0}" -f $encoded)} -Method Delete -Body ($newAssetGroup|ConvertTo-Json) -ContentType "application/json"
$newAssetGroup = $apiResponse.Data

Write-Host "All done!"

################################
#
# The API Response will contain three fields:
#
# Total: The total number of data items that conform to the parameters of the service call. This is useful if you perform paging.
# Data: The data item or list of data items
# Message: The error message if the API call fails
#
################################